<?php

class Entry
{
    public $comments=array();
    public $categories=array();
    public $id;
    public $title;
    public $text;
    public $date;
    public $html_solo;
    public $htmlcode;
    public $writerdata;
    
    function __construct($datas, $comments, $relations, $comment_setting, $writerdata, $lng)
    {
        $this->id = $datas["id"];
        $this->title = $datas["title"];
        $this->text = $datas["main"];
		$this->detailed_date = $datas["date"];
		$this->keywords = $datas["keywords"];
        $this->date = date('m/d/Y', strtotime($datas["date"]));
        $this->writerdata = $writerdata;
        
        $this->comments = $comments;
        $this->categories = $relations;
        
        $this->html_solo = $this->html("solo", $comment_setting, $lng);
        $this->htmlcode = $this->html("", $comment_setting, $lng);
    }
    
    function html($type, $comment_setting, $lng)
    {
        $code = 
        '
        <div class="entry">
            <div class="title">
                <a href="entry-'.$this->id.'.html">
                '.$this->title.'</a>
            </div>
            <div class="maintext">
                ';
                
        if ($type != "solo")
        {
            $pos = stripos($this->text, "[READMORE]");
            if ($pos == "")
                { $mytext = $this->text; }
            
            else
                { $mytext = substr($this->text, 0, $pos).
                  '<br/><a href="entry-'.$this->id.'.html" class="readmore">'.$lng["readmore"].'</a>'; }
            
            $code .= $mytext;
        }
        
        else
        {
            $code .= ereg_replace("\[READMORE\]", "", $this->text);
        }
        
        $code .= '
			</div>';
			
		if (count($this->categories)!=0)
		{
            $code .= '<div class="categories">
                '.$lng["categories"].': *-*-CATEGORIES-*-*
			</div>
        ';
		}
        
        if ($comment_setting == "both" || $comment_setting == "show")
        {
            $code = $code.'
            <div class="bottom">
                '.$lng["comments"].'('.count($this->comments).')
            </div>
            ';
        }
        $code = $code.'
			<div class="date">
                '.$this->date.'
            </div>
            <div class="writer">
                '.$this->writerdata["name"].'
            </div>
			<div class="keywords">
				'.$lng["keywords"].': '.$this->keywords.'
			</div>
        </div>
        <br/>
        ';
        $cats = " - ";
        foreach($this->categories as $category)
            {$cats = $cats.'<a href="category-'.$category["id"].'">'.$category["name"].'</a> - ';}
        
        $code = ereg_replace("\*\-\*\-CATEGORIES\-\*\-\*", $cats, $code);
        
        #COMMENTS
        if($type == "solo")
        {
        if ($comment_setting == "both" || $comment_setting == "show")
        {
            foreach($this->comments as $thing)
            {
				if ($thing["website"])
				{
					$code = $code.'
					<div class="comment">
						<div class="subject"><a href="'.$thing["website"].'" target="_blank">'.$thing["who"].'&nbsp;('.$thing["date"].')</a></div>
						<div class="text">'.$thing["comment"].'</div>
					</div>';
				}
				
				else
				{
					$code = $code.'
					<div class="comment">
						<div class="subject">'.$thing["who"].'&nbsp;('.$thing["date"].')</div>
						<div class="text">'.$thing["comment"].'</div>
					</div>';
					
				}
            }
        }
        
        if ($comment_setting == "both")
        {
            $code = $code.'
            <div class="newcomment">
                <form action="../new_comment.php" method="POST">
                '.$lng["name"].'<br>
                <input type="text" id="who" name="who" maxlength="120"><br><br>
                
                '.$lng["website"].'<br>
                <input type="text" id="website" name="website" maxlength="120"><br><br>

                '.$lng["comment"].'<br>
                <textarea name="comment" id="comment" rows="8" cols="40"></textarea><br><br/>
				
				<img id="captcha" src="../admin/securimage/securimage_show.php" alt="CAPTCHA Image" /><br/>
				'.$lng["entercode"].'<br/>
				<input type="text" name="captcha_code" size="10" maxlength="4" />
				<input type="hidden" id="'.$this->id.'" name="eid" value="'.$this->id.'">

                <input type="submit" value="'.$lng["submit"].'">
                </form>
            </div>';
        }
        }
        
        return $code;
            
    }
        
}
?>
