<?php
/* Comment.php *
 * The users can manage the comments through this script
 * 
 * Root User and admins can manage all comments
 * 
 * Writers can manage only their enties' comments
 */



/*
 * Start the session
 * If session has not started go to login.php
 */

session_start();
if (!($_SESSION["class"] == "admin" || $_SESSION["class"] == "root" || $_SESSION["class"] == "writer"))
{
    header("Location: login.php"); exit();
}




/*
 * From db.php get DataBase class
 * Make a new DataBase Object
 */

require("./db.php");
$DB = new DataBase();

require("../langs/".$DB->get_setting("lang").".php");
$lng = $_lang["comment.php"];
$lng["returntomanager"] = $_lang["returntomanager"];



/*
 * Get Do variable
 * This will tell the script what it will do
 */

$do = $_REQUEST["do"];




/*
 * If there is no "do"
 * 
 * Script will show all comments
 * 
 * There is two types of comments
 * 1-) DataBase (confirmed) comments
 * 2-) Temporary comments
 * 
 * A comment first goes to temp directory
 * The comments at temp directory are Temporary Comments
 * They wait for a confirmation from admins or the related user
 * 
 * DataBase comments are confirmed comments
 * These are stored in DataBase
 */

if ($do=="")
{
    /*
     * There are two classes
     * First, the "comment" class for the DataBase Comments
     * Second, the "tc" class for the Temp Comments
     * These classes is stored in class.comments.php file
     */
    
    require('class.comments.php');
    
    
    
    
    /*
     * Making Temp comments array
     * 
     * Opening temp directory
     * Getting comment xml files
     * Making a tc object
     * If the user have management rights on this comment add the object to "tempc" array
     */
	
	$bt = $DB->get_setting("browsingtype");
    $tempc = array();
    $open = opendir("../temp/");
    
    while($x=readdir($open)) 
    { 
        if ($x != "." && $x != ".." && substr($x, -4) == ".xml" && substr($x, 0, 7) == "comment") 
        {
            $t = new tc($x, $lng, $bt); 
            $a = $DB->get_entry($t->entry);
            if (!($_SESSION["class"] == "writer" && $a["writer"] != $_SESSION["data"]["id"]))
                { $tempc[] = $t; }
        } 
    }




    /*
     * Making DataBase comments array
     * 
     * Getting all comments from database
     * If the user have managament rights on the comment,
     * Make an object and add it to "$comments" array
     */
    
    $all_comments = $DB->all_comments();
    $comments = array();
    foreach($all_comments as $comm)
    {
        $a = $DB->get_entry($comm["entry"]);
        if (!( $_SESSION["class"] == "writer" && $a["writer"] != $_SESSION["data"]["id"]))
            { $comments[] = new comment($comm, $lng, $bt); }        
    }
    
    
    
    
    /*
     * Making panel
     */
    
    $page_title= $lng["comments"];
    $side1 = "";
    $side2 = '
        <a href="index.php">'.$lng["returntomanager"].'</a><br/>';
    
    
    
    
    /*
     * Add the comment objects' html codes to "$side1"
     */
    
    
    $temphtml = '<table>'.
	'<caption>'.$lng["waitingverification"].'</caption>'.
	'<tr><td></td><td></td><td><b>'.$lng["writer"].'</b></td><td><b>'.$lng["website"].'</b></td><td><b>'.$lng["comment"].'</b></td><td><b>'.$lng["date"].'</b></td></tr>';
    foreach($tempc as $x)
        { $temphtml = $temphtml.$x->htmlcode; }
    $temphtml .= "</table>";      
    $side1 .= $temphtml;
    $side1 .= '<a href="comment.php?do=delalltemp">'.$lng["delalltemp"].'</a><br/>';
    
    $commhtml = '<br/><br/><br/><table>'.
	'<caption>'.$lng["systemcomments"].'</caption>'.
	'<tr><td></td><td><b>'.$lng["writer"].'</b></td><td><b>'.$lng["comment"].'</b></td><td><b>'.$lng["date"].'</b></td></tr>';
    foreach($comments as $x)
        { $commhtml = $commhtml.$x->htmlcode; }
    $commhtml = $commhtml."</table>";
    $side1 = $side1."<br/>
    ".$commhtml;
    
    
    
    
    /*
     * Make a panel object
     * Show it
     */
    
    require('./panel.php');        
    $panel = new Panel();
    $panel->show($page_title, $side1, $side2);
}




/*
 * If "do" equals "deltemp"
 * It means delete a temporary comment
 */

elseif ($do == "deltemp")
{
    /*
     * Define a parsing function
     * Get comment's related writer's data
     * If the user has rights for deleting this comment continue
     * else go to login.php
     */
    
    function parsingg($what, $xml)
    {
        if ( ereg("<".$what.">.*</".$what.">", $xml, $value))
        {
            $x = trim($value[0]);
            $number = strlen($x)-(2*strlen($what)+5);
            $x = substr($x, strlen($what)+2, $number);
            return $x;
        }
        else
            { return ""; }
    }
    
    $file = $_GET["file"];

    if (!(file_exists("../temp/".$file)))
        { header("Location: login.php"); exit();}
    
    
    $xmlfile = fopen("../temp/".$file, "r");
    
    $xml = "";
    while (!feof($xmlfile)) 
        { $xml .= fgets($xmlfile); }

    
    $entry_id = parsingg("entry", $xml);
    $a = $DB->get_entry($entry_id);
    if (!($_SESSION["class"] == "writer" && $a["writer"] != $_SESSION["data"]["id"]))
    {
        unlink("../temp/".$file);
        header("Location: comment.php");
        exit();
    }
        
    else
        { header("Location: login.php"); exit();}
    
}




elseif ($do == "delalltemp")
{
    $ok = $_GET["ok"];
    require('class.comments.php');
    
    $tempc = array();
    $open = opendir("../temp/");
    
    while($x=readdir($open)) 
    { 
        if ($x != "." && $x != ".." && substr($x, -4) == ".xml" && substr($x, 0, 7) == "comment") 
        {
            $t = new tc($x, $lng); 
            $a = $DB->get_entry($t->entry);
            if (!($_SESSION["class"] == "writer" && $a["writer"] != $_SESSION["data"]["id"]))
                { $tempc[] = $t; }
        } 
    }
    
    if ($ok)
    {
        foreach($tempc as $x)
            { unlink("../temp/".$x->file); }
            
        $side1 = "<h2>".$lng["alltempdeleted"]."</h2>";
        $side2 = '<a href="index.php">'.$lng["returntomanager"].'</a><br/>
		         <a href="comment.php">'.$lng["returntocomments"].'</a><br/>';
        $page_title = $lng["alltempdeleted"];
    }
    
    else
    {
        $temphtml = '
        '.$lng["tcwillbedeleted"].'<br/><br/><br/>
        <table border="0">'.
		'<caption>'.$lng["waitingverification"].'</caption>'.
		'<tr><td></td><td></td><td><b>'.$lng["writer"].'</b></td><td><b>'.$lng["website"].'</b></td><td><b>'.$lng["comment"].'</b></td><td><b>'.$lng["date"].'</b></td></tr>';
        foreach($tempc as $x)
            { $temphtml = $temphtml.$x->htmlcode; }
        $temphtml .= '</table>';
        
        $side1 = $temphtml;
        $side2 = '<a href="comment.php?do=delalltemp&ok=1">'.$lng["apply"].'</a><br/>
				  <a href="comment.php">'.$lng["returntocomments"].'</a><br/>
				  <a href="index.php">'.$lng["returntomanager"].'</a><br/>';
        $page_title = $lng["applytitle"];
    }
    
    require('./panel.php');        
    $panel = new Panel();
    $panel->show($page_title, $side1, $side2);
}




/*
 * If "do" equals "accept"
 * It means a temporary comment accepted and it will be inserted into DataBase
 */

elseif ($do == "accept")
{
    /*
     * Get the xml file that contains the comment data
     * Import class.comments.php file for "tc" class
     * Make a new tc object
     */
    
    $fn = $_GET["file"];
    
    if (!(file_exists("../temp/".$fn)))
        { header("Location: index.php"); exit();}
    
    require('class.comments.php');
    $comment = new tc($fn);
    
    /*
     * If the user has rights on the comment continue
     * Else go to the login.php
     */
    
    $a = $DB->get_entry($comment->entry);
    if (!($_SESSION["class"] == "writer" && $a["writer"] != $_SESSION["data"]["id"]))
    {
        /*
         * Put all variables to a clear look
         */		
        $who = $comment->who;
        $date = $comment->date;
        $entry = $comment->entry;
        $website = $comment->website;
		$comment = $comment->comment;
        
        /*
         * Insert the Comment into the DataBase
         * Delete temp file of the Comment
         * Go to Make_Site.php
         */
        
        $DB->new_comment($who, $website, $entry, $comment, $date);
        unlink("../temp/".$fn);
		$_SESSION["from"] = "comment.php";
        header("Location: make_site.php");
        exit();
    }
    
    else
        { header("Locatin: index.php"); exit(); }
}




elseif ($do == "delcom")
{
    
    $id = $_GET["id"];
    $comment = $DB->get_comment($id);
    $a = $DB->get_entry($comment["entry"]);
    if (!($_SESSION["class"] == "writer" && $a["writer"] != $_SESSION["data"]["id"]))
    {
        $DB->delete_comment($id);
        header("Location: make_site.php");
        exit();
    }
    
    else
    {
        header("Location: index.php"); exit();
    }
}

else
{
    header("Location: index.php"); exit();
}

?> 
