<?php

/* ENTRY.PHP *
 * This script contains the code about entries
 * New entry, editing and deleting
 */


/*
 * Start session
 * If user's session was not made
 * Go to login.php
 */

session_start();
if (!(isset($_SESSION["class"])))
{
    header("Location: login.php"); exit();
}



/*
 * Import Database Class from db.php
 * Make a new DataBase Object
 */

require('./db.php');
$DB = new DataBase();


require("../langs/".$DB->get_setting("lang").".php");
$lng = $_lang["entry.php"];
$lng["returntomanager"] = $_lang["returntomanager"];


function texteditor($text)
{
    $code = file_get_contents('code.texteditor');
    $code = ereg_replace("TEXTWILLBEHERE", $text, $code);
    return $code;   
}




/*
 * Get the "do" variable
 * It tells the script what it must do
 */

$do = $_REQUEST["do"];




/*
 * If "do" equals "new"
 * A "New Entry" panel will be shown
 */

if ($do=="new")
{
    
    /* 
     * If "accept" variable has been defined
     * Do the "New Entry" operation on DataBase
     * 
     * It means the user has been filled the form and pressed the Submit button
     * 
     * "accept" variable is defined in a hidden input 
     */
    
    if ($_REQUEST["accept"])
    {
        $title = $_POST["title"];
        $main = $_POST["texteditor"];
        $writer = $_POST["writer"];
        $categories = $_POST["categories"];
		$keywords = $_POST["keywords"];
        $DB->new_entry($title,$main,date(DATE_RSS), $writer, $keywords);
        $id = $DB->get_id($title,$main,date(DATE_RSS));
        if ($categories) { foreach($categories as $category) { $DB->new_relation($id, $category); } }
		$_SESSION["from"] = "entries.php";
        header("Location: make_site.php"); exit();
    }   




    /*
     * If the "accept" variable has not been defined
     * It means the user has not filled the form
     * 
     * So the script will show a New Entry Form
     * 
     * The Script uses the panel class to show the form
     */
    
    else
    {
        $page_title = $lng["newentry"];
        
        $side1 = '
        <form name="values" id="values" method="post" action="entry.php">
        '.$lng["title"].': <input type="text" name="title" id="title" \><br \>
        <br/>';
        
        $side1 = $side1.texteditor("");
		$side1 .= '<div id="readmorehint">'.$lng["readmorehint"].'</div>';         
        $side1 = $side1.'
        <br/><u><b>'.$lng["categories"].'</b></u><br/>
        ';
        $categories = $DB->get_categories();
        foreach($categories as $category)
            {$side1 = $side1. '
            <input type="checkbox" value="'.$category["id"].'" name="categories[]"/> '.$category["name"].'<br />';}
			
		$side1 .= '
		<br/>'.$lng["keywords"].': <input type="text" name="keywords" id="keywords"/><br/>
		<span style="font-size: 9px;">'.$lng["commahint"].'</span><br/>
		';
        $side1 = $side1. '
        <input type="hidden" name="do" id="do" value="new" />
        <input type="hidden" name="accept" id="accept" value="1" />
        <input type="hidden" name="writer" id="writer" value="'.$_SESSION["data"]["id"].'" />
        <br \>
        <input type="submit" value="'.$lng["submit"].'" \>
        </form>
        ';
        
        $side2 = '<a href="index.php">'.$lng["returntomanager"].'</a><br/>'.
		'<a href="entries.php">'.$lng["returntoentries"].'</a>';
        require('./panel.php');        
        $panel = new Panel();
        $panel->show($page_title, $side1, $side2);

    }
}




/* 
 * If the "do" variable equals "edit"
 */
elseif ($do=="edit")
{
    /*
     * If "accept" variable has been defined 
     * It means the user has edited the entry
     * 
     * The script will make a "DataBase Operation"
     */
    
    if ($_REQUEST["accept"])
    {
        $id = $_POST["id"];
        $a = $DB->get_entry($id);
        
        if (!($a))
            { header("Location: login.php"); exit(); }
        
        if ( $_SESSION["class"]=="writer" && $a["writer"] != $_SESSION["data"]["id"])
            { header("Location: login.php"); exit();}
            
        $title = $_POST["title"];
        $text = $_POST["texteditor"];
        $categories = $_POST["categories"];
		$keywords = $_POST["keywords"];
        $date = $_POST["date"];
        $DB->edit_entry($id, $title, $text, $keywords);
        $DB->delete_relations("entry", $id);
        if($categories) { foreach($categories as $y) { $DB->new_relation($id, $y);} }
		$_SESSION["from"] = "entries.php";
        header("Location: make_site.php");
        exit();
    }
    
    
    
    
    /*
     * If "accept" variable has not been defined
     * It means the user has not edited the entry yet
     * 
     * The script will show a editing entry form
     */
    
    else
    {
        /* 
         * Get the id of the entry that will be edited
         * From the id, get All data about entry
         */
        
        $id = $_REQUEST["entry_id"];
        $entry = $DB->get_entry($id);
        
        
        
        
        /*
         * If the id is not correct
         */
        
        if (!($entry))
            { header("Location: index.php"); exit();}
        
        
        
        
        /*
         * If the user is a writer and the entry's writer is not the user
         * Go to Login.php
         */
        
        if ( $_SESSION["class"]=="writer" && $entry["writer"] != $_SESSION["data"]["id"])
            { header("Location: login.php"); exit();}
        
        
        
        
        /*
         * Get the relations (categories) of the entry
         */
        $relations = $DB->get_relations("entry", $id);
        
        
        
        
        /*
         * Panel variables being defined
         * 
         * $side1 will be our form's html code
         */
        
        $page_title = $lng["editentry"];
        
        $side1 = '
        <form name="values" id="values" method="post" action="entry.php">
        '.$lng["title"].': <input type="text" name="title" id="title" value="'.$entry["title"].'" \><br \><br \>';
        $side1 = $side1.texteditor($entry["main"]);
		$side1 .= '<div id="readmorehint">'.$lng["readmorehint"].'</div>'; 
        
        $categories = $DB->get_categories();
        if ($categories) {
        $side1= $side1.'<u><b>'.$lng["categories"].'</b></u><br/>';
        foreach($categories as $category)
            {
            $selected = 0;
            foreach($relations as $rel) { if ($rel == $category["id"]) { $selected=1; } }
            if ($selected) { $side1 = $side1.'
            <input type="checkbox" value="'.$category["id"].'" name="categories[]" checked="checked"> '.$category["name"].'<br />'; }
            else { $side1 = $side1.'<input type="checkbox" value="'.$category["id"].'" name="categories[]" > '.$category["name"].'<br />'; }
            }   }
		
		$side1 .= '
		<br/>'.$lng["keywords"].': <input type="text" name="keywords" id="keywords" value="'.$entry["keywords"].'"/><br/>
		<span style="font-size: 10px; font-weight: 100;">'.$lng["commahint"].'</span><br/>
		';
		
        $side1 = $side1.'
        <input type="hidden" name="do" id="do" value="edit" \>
        <input type="hidden" name="date" id="date" value="'.$entry["date"].'" \>
        <input type="hidden" name="accept" id="accept" value="1" \>
        <input type="hidden" name="id" value="'.$id.'" \>
        <br \>
        <input type="submit" value="'.$lng["submit"].'" \>
        </form>
        ';
        
        $side2 = '<a href="index.php">'.$lng["returntomanager"].'</a><br/>'.
		'<a href="entries.php">'.$lng["returntoentries"].'</a>';
        
        
        
        
        /*
         * Create a new Panel Object
         */
        
        require('./panel.php');        
        $panel = new Panel();
        $panel->show($page_title, $side1, $side2);
        
    }
}




elseif ($do == "del")
{
    $id = $_REQUEST["id"];
    $a = $DB->get_entry($id);
    
    
    
    
    /*
     * If the id is not correct
     */
    
    if (!($a))
            { header("Location: index.php"); exit();}
            
            
    
    
    /*
     * If the user is a writer and the entry is not the user's
     * Do NOT Allow This
     */
    
    if ( $_SESSION["class"]=="writer" && $a["writer"] != $_SESSION["data"]["id"] )
            { header("Location: login.php"); exit(); }
    
    
    
            
    $DB->delete_entry($id);
    $DB->delete_relations("entry", $id);
	
    $_SESSION["from"] = "entries.php";
    header("Location: make_site.php");
    exit();
}
?>
