<?php
/*
 * Make_site.php *
 * This script builds the blog
 * The Blog's all pages will be static html pages
 */




/*
 * Starting session
 * Only users can run this script
 * If the session class has not set
 * Go to login.php
 */

session_start();
if (!(isset($_SESSION["class"])))
{
    header("Location: login.php"); exit();
}



/*
 * Import DataBase class
 * make a new DataBase Object
 */

require('./db.php');
$DB = new DataBase();

require("../langs/".$DB->get_setting("lang").".php");
$lng = $_lang["make_site.php"];
$lng["returntomanager"] = $_lang["returntomanager"];

function EmptyDir($dir) 
{
    $handle=opendir($dir);

    while (($file = readdir($handle))!==false) 
    {
		if ($file != "show.php")
			{ @unlink($dir.'/'.$file); }
    }

    closedir($handle);
}
EmptyDir('../pages'); 

if ($DB->get_setting("browsingtype") == "dynamic")
{
	$side1 = '
	<h1>'.$lng["blogisready"].'</h1><br/>
	';

	$side2 = '
	<a href="index.php">'.$lng["returntomanager"].'</a><br/>
	<a href="../index.htm" target="_blank">'.$lng["showblog"].'</a><br/>
	';
	$page_title = $lng["blogisready"];

	if ($_SESSION["from"])
	{
		header("Refresh: 3; url=".$_SESSION["from"]);
		$side2 .= '<a href="'.$_SESSION["from"].'">'.$lng["return"].'</a>';
		$_SESSION["from"] = "";
	}

	else
	{
		header("Refresh: 3; url=./");
	}


	require('./panel.php');        
	$panel = new Panel();
	$panel->show($page_title, $side1, $side2);
	
	exit();
}

/*
 * Import class.entry.php for class Entry
 * This class makes our work easier
 */

require('class.entry.php');




/*
 * Getting all entry data from the DataBase
 * Creating our $entries array
 */

$get_entries = $DB->get_entries();
$entries = array();




/*
 * Foreach entry
 * Getting relations(categories) of entry
 * Putting this categories into an array
 * Getting all comments of entry
 * Getting allow_comments setting
 * Getting data of writer of the entry
 * With all of these creating a new Entry Object
 * And putting it into $entries array
 */

foreach($get_entries as $entry)
{
    $rel = $DB->get_relations("entry", $entry["id"]);
    $categories = array();
    foreach($rel as $x) { $categories[] = $DB->get_category_info($x); }
    $comments = $DB->get_comments($entry["id"]);
    $comment_setting = $DB->get_setting("allow_comments");
    $writerdata = $DB->get_user_data($entry["writer"]);
    $entries[] = new Entry($entry, $comments, $categories, $comment_setting, $writerdata, $lng);
}

function sort_entries($entries)
{
	$x = $entries;
	for($i = 0; $i < count($entries)-1; $i += 1)
	{
		for($j = $i+1; $j < count($entries); $j += 1)
		{
			if (strtotime($x[$i]->detailed_date) < strtotime($x[$j]->detailed_date))
			{
				$t = $x[$j];
				$x[$j] = $x[$i];
				$x[$i] = $t;
			}
				
		}
	}
	return $x;
}

$entries = sort_entries($entries);



/*
 * Getting some settings
 * These settings will be used in pages
 */

$epp = $DB->get_setting("entries_per_page");
$blog_title = $DB->get_setting("title");
$site_name = $DB->get_setting("header");
$site_desc = $DB->get_setting("description");
$site_footer = $DB->get_setting("footer");
$site_rss = '<link rel="alternate" type="application/rss+xml" href="'.$DB->get_setting("siteaddress")."rss.php".'" title="'.$site_name.'" />';
$side_address = $DB->get_setting("siteaddress");
$style = $DB->get_setting("skin");





/*
 * Getting our html code and assigning it to variable $html_code
 */

$html_file = fopen("../style/".$style."/HTML.html", "r");
$html_code = "";
while (!feof($html_file)) 
{
$line_of_text = fgets($html_file);
$html_code .= $line_of_text;
}




/*
 * Using our settings on our code
 */

$html_code = ereg_replace("\*\-\*\-NAME\-\*\-\*", $site_name, $html_code);
$html_code = ereg_replace("\*\-\*\-DESC\-\*\-\*", $site_desc, $html_code);
$html_code = ereg_replace("\*\-\*\-FOOTER\-\*\-\*", $site_footer, $html_code);
$html_code = ereg_replace("\*\-\*\-HEAD\-\*\-\*", $site_rss, $html_code);
$html_code = ereg_replace("\*\-\*\-LINK\-\*\-\*", $side_address, $html_code);




/*
 * My paginator generating function
 */

function page_switcher($total, $current)
{
    $total = $total+1;
    $current = $current+1;
    $html = '<div class="pagination">';
    
        if ($total<=5)
        {
            $first = 1;
            $last = $total;
        }
        
        elseif ($current<4)
        {
            $first = 1;
            $last = 5;
        }
        
        elseif ($current>$total-3)
        {
            $first = $total-4 ;
            $last = $total;
        }
        
        else
        {
            $first = $current-2;
            $last = $current+2;
        }
		
		if ($first != 1)
		{
			$html .= '<a href="index0.html">&#60;&#60;</a>';
		}
		
        for($i=$first; $i<=$last; $i++)
            {
                if ($i==$current)
                {
                    $html = $html.'<span class="current_page">'.$i.'</span>';
                }
            
                else
                {
                    $html = $html.'<a href="index'.($i-1).'.html">'.$i.'</a>';
                }
            }
			
		if ($last != $total)
		{
			$html .= '<a href="index'.($total-1).'.html">&#62;&#62;</a>';
		}
        
        $html = $html.'</div>';
    return $html;
}







/*
 * A simple function for making empty directories
 * And making pages directory empty
 */






/*
 * Getting all categories from DataBase
 * Putting them into the array $categories
 */

$get_categories = $DB->get_categories();   
$categories = array();
foreach($get_categories as $category)
{
    $categories[] = array(
    "id" => $category["id"],
    "name" => $category["name"], 
    "description" => $category["description"], 
    "members" => array());
}




/*
 * Putting related entries into the each category's members array
 */

foreach($categories as &$category)
{
    foreach($entries as $entry)
    {
        foreach ($entry->categories as $cat)
        {
            if ($cat["id"] == $category["id"])
                { $category["members"][] = $entry; break;}
        }
    }
}




/*
 * 
 */

$sidebar = "";

$open = opendir("../widgets/");
    
while($x=readdir($open)) 
{ 
    if ($x != "." && $x != ".." && substr($x, -4) == ".php" && substr($x, 0, 7) == "widget_") 
    {
        $function = 'make_'.substr($x, 0, -4);
        include_once("../widgets/".$x);
        $code = $function($DB, "static");
        $sidebar .= '<div class="widget">'.$code.'</div><br/>'."\n";
    }
	
	elseif ($x != "." && $x != ".." && (substr($x, -5) == ".html" || substr($x, -4) == ".htm") && substr($x, 0, 11) == "htmlwidget_") 
    {
        $widget_file = fopen("../widgets/".$x, "r");
		$widget_code = "";
		while (!feof($widget_file)) 
		{
			$line_of_text = fgets($widget_file);
			$widget_code .= $line_of_text;
		}
		
		fclose($widget_file);
        $sidebar .= '<div class="widget">'.$widget_code.'</div><br/>'."\n";
    }
}

$html_code = ereg_replace("\*\-\*\-THESIDEBAR\-\*\-\*", $sidebar, $html_code);




/*
 * If there isn't any entries
 * Just make a page that telling it
 */

if (count($get_entries) == 0)
{
    $xyz = ereg_replace("\*\-\*\-CONTENT\-\*\-\*", $lng["noentryinblog"], $html_code);
    $xyz = ereg_replace("\*\-\*\-TITLE\-\*\-\*", $blog_title, $xyz);
	$xyz = ereg_replace("\*\-\*\-DESCRIPTION\-\*\-\*", $blog_title, $xyz);
	$xyz = ereg_replace("\*\-\*\-KEYWORDS\-\*\-\*", $blog_title, $xyz);
    touch("../pages/index0.html");
    $my_file = fopen("../pages/index0.html", "w");
    fwrite($my_file, $xyz);
    fclose ($my_file);
    
    
    $side1 = '
    <h2>'.$lng["noentryinblog"].'</h2><br/>
    ';

    $side2 = '
    <a href="index.php">'.$lng["returntomanager"].'</a><br/>
    <a href="../index.htm" target="_blank">'.$lng["showblog"].'</a>';
    $page_title = "Henüz bir yazı bulunmuyor.";


    require('./panel.php');        
    $panel = new Panel();
    $panel->show($page_title, $side1, $side2);
    exit();
}
$entries = sort_entries($entries);



/*
 * Making each category's html pages
 */

foreach ($categories as &$category)
{
    $content = "";
    foreach($category["members"] as $entry)
        { $content = $content.$entry->htmlcode; }
		
	$description = $category["name"]." - ".$category["description"];
	$member = $category["members"][0];
	$keywords = $category["name"].", ".$category["description"].", ".$member->keywords;
            
    $html = ereg_replace("\*\-\*\-CONTENT\-\*\-\*", $content, $html_code);
    $html = ereg_replace("\*\-\*\-TITLE\-\*\-\*", $category["name"]." - ".$blog_title, $html);
	$html = ereg_replace("\*\-\*\-DESCRIPTION\-\*\-\*", $description , $html);
	$html = ereg_replace("\*\-\*\-KEYWORDS\-\*\-\*", $keywords, $html);
	
    touch("../pages/category-".$category["id"].".html");
    $new_file = fopen("../pages/category-".$category["id"].".html", "w");
    fwrite($new_file, $html);
    fclose ($new_file);
}


foreach($entries as $entry)
{
    $solo_html = ereg_replace("\*\-\*\-CONTENT\-\*\-\*", $entry->html_solo, $html_code);
    $solo_html = ereg_replace("\*\-\*\-TITLE\-\*\-\*", $entry->title." - ".$blog_title, $solo_html);
	$solo_html = ereg_replace("\*\-\*\-DESCRIPTION\-\*\-\*", $entry->title , $solo_html);
	$solo_html = ereg_replace("\*\-\*\-KEYWORDS\-\*\-\*", $entry->keywords , $solo_html);
    touch("../pages/entry-".$entry->id.".html");
    $solo_file = fopen("../pages/entry-".$entry->id.".html", "w");
    fwrite($solo_file, $solo_html);
    fclose ($solo_file);
}




/*
 * Making index files 
 * The index files are main pages of the blog
 */

$page_number = floor(count($entries)/$epp);
if ($page_number == count($entries)/$epp) { $page_number--; }
$count = 0;

while($count<=$page_number)
{
    $content = "";
    $subcounter = 0;
    if ($count != $page_number)
    {
        while($subcounter < $epp)
        {
            $entry = $entries[$count*$epp +$subcounter];
            $content = $content.$entry->htmlcode;
            $subcounter++;
        }
    }
    
    else
    {
        while($subcounter < count($entries)-($epp*$page_number ))
        {
            $entry = $entries[$count*$epp +$subcounter];
            $content = $content.$entry->htmlcode;
            $subcounter++;
        }
    }
    $pages = page_switcher($page_number, $count);
    $content = $content.$pages;
    $new_html = ereg_replace("\*\-\*\-CONTENT\-\*\-\*", $content, $html_code);
    $new_html = ereg_replace("\*\-\*\-TITLE\-\*\-\*", $blog_title, $new_html);
	
	$description = $site_desc;
	$keywords = "";
	
	foreach($categories as $cat)
	{
		$keywords .= $cat["name"].", ".$cat["description"].", ";
	}
	$keywords .= $site_desc.", ";
	$keywords .= $entries[0]->keywords;
	
	$new_html = ereg_replace("\*\-\*\-DESCRIPTION\-\*\-\*", $description, $new_html);
	$new_html = ereg_replace("\*\-\*\-KEYWORDS\-\*\-\*", $keywords, $new_html);
	
    touch("../pages/index".$count.".html");
    $new_file = fopen("../pages/index".$count.".html", "w");
    fwrite($new_file, $new_html);
    fclose ($new_file);
    
    $count=$count+1;
}




/*
 * All work has been done
 * Just show the panel to the user
 */



$side1 = '
<h1>'.$lng["blogisready"].'</h1><br/>
';

$side2 = '
<a href="index.php">'.$lng["returntomanager"].'</a><br/>
<a href="../index.htm" target="_blank">'.$lng["showblog"].'</a><br/>
';
$page_title = $lng["blogisready"];

if ($_SESSION["from"])
{
	header("Refresh: 3; url=".$_SESSION["from"]);
	$side2 .= '<a href="'.$_SESSION["from"].'">'.$lng["return"].'</a>';
	$_SESSION["from"] = "";
}

else
{
	header("Refresh: 3; url=./");
}


require('./panel.php');        
$panel = new Panel();
$panel->show($page_title, $side1, $side2);
?> 
