<?php

/* User.php *
 * Through this script, admins can delete, promote or invite users
 * Only the root user and admins can access this script
 */




/*
 * Start session
 * If user is not the root or an admin
 * Go to login.php
 */

session_start();
if (!($_SESSION["class"] == "admin" || $_SESSION["class"] == "root"))
{
    header("Location: login.php");
}




/*
 * Import DataBase class from db.php
 * Create a new DataBase Object
 */

require('./db.php');
$DB = new DataBase();

require("../langs/".$DB->get_setting("lang").".php");
$lng = $_lang["user.php"];
$lng["returntomanager"] = $_lang["returntomanager"];


/*
 * Get "do" variable
 * It tells the script what it will do
 */

$do = $_REQUEST["do"];




/*
 * If "do" equals "new"
 * A "New User Operation" will be performed
 */

if ($do == "new")
{
    
    /*
     * Get "ok" variable
     * If Ok, send a mail to the user that has been invited
     * Else show a simple form that request an e-mail address
     */
    
    $ok = $_POST["ok"];
    
    
    
    
    if ($ok)
    {
        
        /*
         * Get the e-mail address
         */
        
        $mail = $_POST["mail"];
        
        
        
        
        /*
         * Check validation of the email address
         */
        
        if (!eregi("^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})$", $mail))
            { header("Location: user.php?do=new&err=1"); exit(); }
            
        
        
        
        /*
         * If the e-mail address is being used
         */
        
        if ($DB->check_email($mail))
            { header("Location: user.php?do=new&err=2"); exit(); }
            
            
            
            
        /*
         * Create a new validation code
         */
        
        $validation = strval(rand());
        
        
        
        
        /*
         * Define the data array
         * It is necessary for our mailer function
         */
        
        $data = array(
            "mail" => $mail, 
            "adminname" => $_SESSION["data"]["nick"],
            "sitename" => $DB->get_setting("header"),
            "address" => $DB->get_setting("siteaddress")."newuser.php?mail=".$mail."&vcode=".$validation 
            );
        
        
        
        
        /*
         * Generate the xml code for the xml file
         */
        
        $xml = 
'<?xml version="1.0"?>
<comment>
<email>'.$mail.'</email>
<validation>'.md5($validation).'</validation>
</comment>
';
        
        
        
        
        /*
         * Open the xml file
         * Write the xml code
         * Close the file
         */
        
        $xmlfile = fopen("../temp/newuser".md5($mail).".xml", "w");        
        fwrite($xmlfile, $xml);
        fclose($xmlfile);
        
        
        
        
        /*
         * Get mailing function
         * Send an e-mail
         */
        
        require('mailer.php');
        if($m = send_mail("newuser", $data, $DB))
        {
            $side1 = $lng["mailerror"].': '.$m;
            $side2 = '<a href="index.php">'.$lng["returntomanager"].'</a><br/>';
            $page_title = $lng["mailerror"]; 
        }
        
        else
        {
            /*
             * Define panel variables
             */
            
            $side1 = $lng["mailsuccess"];
            
            $side2 = '<a href="index.php">'.$lng["returntomanager"].'</a><br/>';
            $page_title = $lng["mailsuccess"];
        }
        
    }
    
    
    
    else
    {
        
        /*
         * Just Define panel variables
         */
        
        if ($_GET["err"] == "1")
            { $error_message = $lng["invalidmail"]; }
            
        elseif ($_GET["err"] == "2")
            { $error_message = $lng["mailexists"]; }
        
        $side1 = $error_message.'<br/>
        '.$lng["needtosendmail"].'<br/><br/>
        <form id="newuser" action="user.php" method="post">
        '.$lng["emailofuser"].'
        <input type="text" id="mail" name="mail"/>
        <input type="hidden" id="ok" name="ok" value="1"/>
        <input type="hidden" id="do" name="do" value="new"/>
        <input type="submit" value="'.$lng["submit"].'">
        </form>';
        
        $side2 = '<a href="index.php">'.$lng["returntomanager"].'</a><br/>';
        $page_title = $lng["newuser"];        
    }
    
    
    
    
    /*
     * Show the panel
     */
    
    require('./panel.php');        
    $panel = new Panel();
    $panel->show($page_title, $side1, $side2);
    
}




/*
 * If "do" equals "promote"
 * An user will be promoted to the admin
 * Only the root user can promote the users
 */

elseif ($do == "promote")
{
    /*
     * If the user is not the root user
     * Go to the index.php
     */
    
    if (!($_SESSION["class"] == "root"))
    {
        header("Location: index.php");
    }
    
    
    
    
    /*
     * Get "ok" variable
     * If ok, just promote
     * Else show something
     */
    
    $ok = $_REQUEST["ok"];
    
    
    
    
    /*
         * Get the id of the user 
         * Get data of the user
         */
        
        $id = $_GET["id"];
        $data = $DB->get_user_data($id);
        
        
        
        
        /*
         * Catch the errors
         */
        
        if (!($data))
            { header("Location: index.php"); exit(); }
            
    
    
    
    if ($ok)
    {
       
        
        /*
         * If the user is not a writer
         * Go to the index.php
         */
        
        if (!($data["class"] == "writer"))
            { header("Location: index.php"); }
        
        
        
        
        /*
         * Promote the user
         */
        
        $DB->promote($id);
        
        
        
        
        /*
         * Define panelvariables
         */
        
        $side1 = $lng["promotedsuccessfully"];
        $side2 = '<a href="index.php">'.$lng["returntomanager"].'</a><br/>';
        $page_title = $lng["promotedsuccessfully"];
    }
    
    
    
    
    else
    {
        
        
            
            
            
            
        /*
         * If the user is a writer
         * Show data of the user and
         * Say "If you are sure, continue"
         */
        
        if ($data["class"] == "writer")
        {
            $side1 = '
            '.$lng["abouttopromote"].' : '.$data["nick"].'<br/>
            <a href="user.php?do=promote&id='.$id.'&ok=1">'.$lng["ifyouresurecontinue"].'</a><br/>
            <h3>'.$lng["userdata"].'</h3>
            <dl>
              <dt>'.$lng["nick"].'</dt>
              <dd>'.$data["nick"].'</dd>
              
              <dt>'.$lng["name"].'</dt>
              <dd>'.$data["name"].'</dd>
              
              <dt>'.$lng["emailaddress"].'</dt>
              <dd>'.$data["email"].'</dd>
              
              <dt>'.$lng["about"].'</dt>
              <dd>'.$data["description"].'</dd>
            </dl>
            ';
            $side2 = '<a href="index.php">'.$lng["returntomanager"].'</a><br/>';
            $page_title = $lng["promote"].' : '.$data["nick"];
        }
        
        
        
        
        /*
         * If the user is not a writer
         * Say "This user is an admin"
         */
        
        else
        {
            $side1 = $lng["alreadyadmin"];
            $side2 = '<a href="index.php">'.$lng["returntomanager"].'</a><br/>';
            $page_title = $lng["alreadyadmin"];
        }
    }
    
    
    
    
    /*
     * Import Panel class
     * Show the panel
     */
    
    require('./panel.php');        
    $panel = new Panel();
    $panel->show($page_title, $side1, $side2);
        
}




/*
 * If "do" equals "delete"
 * It means an user wanted to delete
 */

elseif ($do == "delete")
{
    /*
     * Get id of the user
     * Get data of the user
     */
    
    $id = $_GET["id"];
    $user = $DB->get_user_data($id);
    
    
    
    
    /*
     * If the operating user is not the root and 
     * he/she trying to delete a non-writer user
     * Or the user wanted deleted is the root
     * 
     * Go to the index.php
     */
    
    if (($_SESSION["class"] != "root" && $user["class"] != "writer") || $user["class"] == "root")
        { header("Location: index.php"); exit(); }
        
    if (!($user))
        { header("Location: index.php"); exit(); }
        
    
    
    
    /*
     * Delete the user
     */
    
    $DB->delete_user($id);
    
    
    
    
    /*
     * Go to the user.php
     */
    
    header("Location: user.php");     
}




/*
 * If there is no "do"
 * Show a list of users
 */

else
{
    
    /*
     * Defining the User class
     */
    
    class User
    {
        public $name;
        public $nick;
        public $mail;
        public $password;
        public $description;
        public $class;
        public $id;
        public $seer;
        public $table_code;
        
        function __construct($data, $seer, $lng="")
        {
            $this->name = $data["name"];
            $this->nick = $data["nick"];
            $this->mail = $data["email"];
            $this->password = $data["password"];
            $this->description = $data["description"];
            $this->class = $data["class"];
            $this->seer = $seer;
            $this->id = $data["id"];
            
            $this->table_code = $this->codegen($lng);
        }
        
        function codegen($lng)
        {
            $code = 
            '
            <tr>
              <td>'.$this->name.'</td>
              <td>'.$this->nick.'</td>
              <td>'.$this->mail.'</td>
              <td>'.$this->class.'</td>';
            
            if ($this->class == "writer" && $this->seer == "root")
            { 
                $code = $code.'
                <td><a href="user.php?do=promote&id='.$this->id.'">'.$lng["promote"].'</a></td>
                <td><a href="user.php?do=delete&id='.$this->id.'">'.$lng["delete"].'</a></td>'; 
            }
            
            elseif ($this->class == "writer" && $this->seer == "admin")
            {
                $code = $code.'
                <td><a href="user.php?do=delete&id='.$this->id.'">'.$lng["delete"].'</a></td>';
            }
            
            elseif ($this->class == "admin" && $this->seer == "root")
            {
                $code = $code.'
                <td><a href="user.php?do=delete&id='.$this->id.'">'.$lng["delete"].'</a></td>';
            }
                
            $code = $code.'
            </tr>';
            
            return $code;
        }
    }
    
    
    
    
    /*
     * Getting all users from database
     */
    
    $userdata = $DB->get_users();
    
    
    
    
    /*
     * Put all of the User objects into the userlist array
     */
    
    $userlist = array();
    foreach ($userdata as $data)
        { $userlist[] = new User($data, $_SESSION["class"], $lng); }
    
    
    
    
    /*
     * Define panel variables
     */
    
    $side1 = '<table>'.
    '<caption><b>'.$lng["users"].'</b></caption>'.
	'<td><b>'.$lng["name"].'</b></td><td><b>'.$lng["nick"].'</b></td><td><b>'.$lng["emailaddress"].'</b></td><td><b>'.$lng["authority"].'</b></td>';
    
    foreach($userlist as $user)
        { $side1 = $side1.$user->table_code; }
        
    $side1 .= '</table>';
    $side2 = '
    <a href="user.php?do=new">'.$lng["newuser"].'</a><br/>
    <a href="index.php">'.$lng["returntomanager"].'</a><br/>';
    
    $page_title = $lng["users"];
    
    
    
    
    /*
     * Import panel.php
     * Create a new panel object and show it
     */
    
    require('./panel.php');        
    $panel = new Panel();
    $panel->show($page_title, $side1, $side2);
        
}





?>
